# std::future< _Res > Class Template Reference
[Futures]

Primary template for future. More...

Inheritance diagram for std::future< _Res >:
[legend]

List of all members.

## Public Member Functions

- future (future &&__uf)
- future (const future &)
- _Res get ()
- future & operator= (const future &)
- future & operator= (future &&__fut)
- bool valid () const
- void wait () const
- template<typename _Rep , typename _Period > bool wait_for (const chrono::duration< _Rep, _Period > &__rel) const
- template<typename _Clock , typename _Duration > bool wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types

- typedef __future_base::_Result
  < _Res > & __result_type

## Protected Member Functions

- __result_type _M_get_result ()
- void _M_swap (__basic_future &__that)

## Friends

- template<typename _Fn , typename... _Args> future< typename result_of
  < _Fn(_Args...)>::type > async (launch, _Fn &&, _Args &&...)
- class packaged_task
- class promise< _Res >

## Detailed Description

### template<typename _Res>
class std::future< _Res >

Primary template for future.

Definition at line 559 of file future.

## Constructor & Destructor Documentation

template<typename _Res >

std::future< _Res >::future | ( | future< _Res > && | __uf | ) | `[inline]`

Move constructor.

Definition at line 577 of file future.

## Member Function Documentation

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | `[inline, protected, inherited]`

Wait for the state to be ready and rethrow any stored exception.

Definition at line 513 of file future.

Referenced by std::shared_future< _Res >::get(), std::future< void >::get(), and std::future< _Res >::get().

template<typename _Res >

_Res std::future< _Res >::get | ( |  | ) | `[inline]`

Retrieving the value.

Definition at line 591 of file future.

References std::__basic_future< _Res >::_M_get_result().

The documentation for this class was generated from the following file:

- future